uniform int uShadeModel;
uniform vec3 UaColor;
uniform vec3 UdColor;
uniform vec3 UsColor;
uniform float Ushine;
uniform int uNormal;

varying vec3 vCol;
varying vec3 norm;
varying vec3 toLight;
varying vec3 view;

void main()
{
    if (uShadeModel != 1 || uNormal == 1)
    {
		gl_FragColor = vec4(vCol.r, vCol.g, vCol.b, 1.0);       
    }
    else
    {
        float diffCoef = dot(normalize(toLight), norm);
        vec3 diffColor = max(0, diffCoef) * UdColor;
        vec3 specCoef = normalize(toLight - view);
        vec3 specColor = UsColor * pow(dot(norm, specCoef), Ushine);
        vec3 ambColor = UaColor * 0.1;

        gl_FragColor = vec4(diffColor + specColor + ambColor, 1.0);
    }

}
