attribute vec4 aPos;
attribute vec3 aNor;
uniform mat4 P;
uniform mat4 uViewMatrix;
uniform mat4 uModelMatrix;
uniform vec3 uLightPos;
//uniform mat4 MV;
//uniform mat4 grotate;
//uniform vec3 color;
uniform vec3 UaColor;
uniform vec3 UdColor;
uniform vec3 UsColor;
uniform float Ushine;
uniform int uShadeModel;
uniform int uNormal;

varying vec3 vCol;
varying vec3 norm;
varying vec3 toLight;
varying vec3 view;

void main()
{
    view = (uViewMatrix * uModelMatrix * aPos).xyz;
    gl_Position = P * uViewMatrix * uModelMatrix * aPos;

    //diffuse
    toLight = (uLightPos - view);
    vec4 beforeNorm = uViewMatrix * uModelMatrix *
        vec4(aNor, 0.0);
    norm = normalize(beforeNorm.xyz);

    if (uNormal == 0)
    {
        float diffCoef = dot(normalize(toLight), norm);
        vec3 diffColor = max(0, diffCoef) * UdColor;
        vec3 specCoef = normalize(toLight - view);
        vec3 specColor = UsColor * pow(dot(norm, specCoef), Ushine);
        vec3 ambColor = UaColor * 0.1;

        vCol = diffColor + specColor + ambColor;
    }
    else
    {
        vCol = 0.5 * (norm + 1.0);
    }

}
